package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.Spice;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author leon on 27/12/2018.
 */
public class Food {
    List<Spice> spices;

    public Food(){
        spices= new ArrayList<>();
    }

    public List<Spice> getAllSpices() {
        return spices;
    }


    public <SpiceType extends Class<? extends Spice>> Map<SpiceType, Integer> getSpiceCount() {
        Map <SpiceType, Integer> count= new HashMap<>();
        spices.forEach ((spice -> {
            if(!count.containsKey(spice.getClass())){
                count.put((SpiceType)spice.getClass(),1);
            }else {
                count.put((SpiceType) spice.getClass(),count.get(spice.getClass())+ 1);
            }
        }));


        return count;
    }

    public void applySpice(Spice spice) {
        spices.add(spice);
    }
}
